#!/usr/bin/env python
# -*- coding: UTF-8 -*-
"""
@Project ：dup1
@File    ：textcnn.py
@Author  ：Zhl
@Date    ：2021/9/10 5:11 下午 
"""
from tensorflow.python.keras.layers import (Embedding)
from tensorflow.python.keras.regularizers import l2

from dup1.feature.feature_column import VarLenSparseFeat
from dup1.feature.feature_column import build_input_features


class TextCNN:

    def __init__(self, dnn_feature_columns, l2_reg_embedding):
        features = build_input_features(dnn_feature_columns)
        print(features)
        varlen_sparse_feature_columns = list(
            filter(lambda x: isinstance(x, VarLenSparseFeat), dnn_feature_columns)) if dnn_feature_columns else []
        embedding_dict = {feat.embedding_name: Embedding(feat.vocabulary_size, feat.embedding_dim,
                                                         embeddings_initializer=feat.embeddings_initializer,
                                                         embeddings_regularizer=l2(l2_reg_embedding),
                                                         name=f"sparse_emb_{i}_{feat.name}")
                          for i, feat in enumerate(["word"])}

