#!/usr/bin/python
# -*- coding:utf-8 -*-
# @Time : 2021/6/10 10:11
# @Author : zhl
# @File : log_util.py


import inspect
import time


class PyLogger:
    def log_print(self, log_type, *msg):
        stack = inspect.stack()
        file_name = stack[2].filename
        method_name = stack[2].function
        line_no = stack[2].lineno
        time_stamp = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
        log_msg = " ".join([str(m) for m in msg[0]])
        print(f"[{time_stamp}] [{log_type}] [{file_name}:{line_no}] [{method_name}] {log_msg}")

    def warn(self, *msg):
        self.log_print("WARN", msg)

    def error(self, *msg):
        self.log_print("ERROR", msg)

    def info(self, *msg):
        self.log_print("INFO", msg)


pylog = PyLogger()
