#!/usr/bin/env python
# -*- coding: UTF-8 -*-
"""
@Project ：dup1
@File    ：metirc.py
@Author  ：Zhl
@Date    ：2021/9/13 10:05 上午 
"""
import numpy as np
from sklearn.metrics import roc_auc_score

from dup1.utils.com_util import pylog


def metric(label, score):
    auc = -1
    label_class = {}
    for i in label:
        if i[0] in label_class:
            label_class[i[0]] = label_class[i[0]] + 1
        else:
            label_class[i[0]] = 1
    if len(set([i[0] for i in label])) > 1:
        auc = roc_auc_score(y_true=label, y_score=score)
    score_bin = {}
    for s in score:
        n = str(np.round(s[0], 1))
        if n in score_bin:
            score_bin[n] = score_bin[n] + 1
        else:
            score_bin[n] = 1
    log = str()
    log += f"auc:{np.round(auc, 6)},"
    log += f" score_dist:"
    for key, val in score_bin.items():
        log += f" {key}:{val}, "
    log += f" label_class:"
    for key, val in label_class.items():
        log += f" {key}:{val},"
    pylog.info(log[:-1])
